Package org.apache.solr.client.solrj.request

## Class RequestWriter

- java.lang.Object
- - org.apache.solr.client.solrj.request.RequestWriter

Direct Known Subclasses:
  `BinaryRequestWriter`, `XMLRequestWriter`

    public class RequestWriter
    extends Object

A RequestWriter is used to write requests to Solr.

A subclass can override the methods in this class to supply a custom format in which a request can be sent.

Since:
  solr 1.4

### Nested Class Summary

Nested Classes
`static interface` `RequestWriter.ContentWriter`
`static class` `RequestWriter.StringPayloadContentWriter`

### Constructor Summary

Constructors
`RequestWriter()`

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`Collection<ContentStream>` `getContentStreams​(SolrRequest<?> req)` Deprecated. Use `getContentWriter(SolrRequest)`.
`RequestWriter.ContentWriter` `getContentWriter​(SolrRequest<?> req)` To be implemented by subclasses to serialize update requests into the appropriate format.
`String` `getPath​(SolrRequest<?> req)` Deprecated.
`String` `getUpdateContentType()`
`protected boolean` `isEmpty​(UpdateRequest updateRequest)`
`protected boolean` `isNull​(List<?> l)`
`protected boolean` `isNull​(Map<?,​?> l)`
`void` `write​(SolrRequest<?> request, OutputStream os)`
`void` `writeXML​(UpdateRequest request, Writer writer)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### RequestWriter

    public RequestWriter()

### Method Detail

#### getContentWriter

    public RequestWriter.ContentWriter getContentWriter​(SolrRequest<?> req)

To be implemented by subclasses to serialize update requests into the appropriate format.

If this method returns null, `getContentStreams(SolrRequest)` is then invoked to get content.

#### getContentStreams

    @Deprecated
    public Collection<ContentStream> getContentStreams​(SolrRequest<?> req)
                                                throws IOException

Deprecated.
Use `getContentWriter(SolrRequest)`.

Throws:
  `IOException`

#### isEmpty

    protected boolean isEmpty​(UpdateRequest updateRequest)

#### getPath

    @Deprecated
    public String getPath​(SolrRequest<?> req)

Deprecated.

#### write

    public void write​(SolrRequest<?> request,
                      OutputStream os)
               throws IOException

Throws:
  `IOException`

#### getUpdateContentType

    public String getUpdateContentType()

#### isNull

    protected boolean isNull​(List<?> l)

#### isNull

    protected boolean isNull​(Map<?,​?> l)

#### writeXML

    public void writeXML​(UpdateRequest request,
                         Writer writer)
                  throws IOException

Throws:
  `IOException`